<?php
namespace Ems\portalGestor\Service;

use Ems\portalGestor\Util\HcmServices;

class ResumoService {

    /** @var HcmServices */
    protected $hcmServices;

    public function __construct(
        HcmServices $hcmServices
    ) {
        $this->hcmServices = $hcmServices;
    }

    public function getSituacoesFreq(
        int $nrOrg
    ) {
        $hcmServicesRoute = 'getSituacoesFreq';

        $params = [
            'requestType' => 'Row',
            'row' => [
                'EMPTY' => null,
            ],
        ];

        $response = $this->hcmServices->send($hcmServicesRoute, $params, $nrOrg);
        $situacoes = $response['dataset'][$hcmServicesRoute];

        return $situacoes;
    }

    public function getResumoFreq(
        array $row
    ) {
        $nrOrg = (int) $row['NRORG'];
        $hcmServicesRoute = 'getResumoFreq';

        $params = [
            'requestType' => 'Row',
            'row' => $row,
        ];

        $response = $this->hcmServices->send($hcmServicesRoute, $params, $nrOrg);
        $resumo = $response['dataset'][$hcmServicesRoute];

        return $resumo;
    }

    public function saveResumoFreq(
        array $row
    ): bool {
        $nrOrg = (int) $row['NRORG'];
        $hcmServicesRoute = 'saveResumoFreq';

        $params = [
            'requestType' => 'Row',
            'row' => $row,
        ];

        $response = $this->hcmServices->send($hcmServicesRoute, $params, $nrOrg);
        $success = $response['dataset'][$hcmServicesRoute]['success'];

        return $success;
    }

    public function gestorCanEditResumo(
        array $row
    ): bool {
        $nrOrg = (int) $row['NRORG'];
        $hcmServicesRoute = 'gestorCanEditResumo';

        $params = [
            'requestType' => 'Row',
            'row' => $row,
        ];

        $response = $this->hcmServices->send($hcmServicesRoute, $params, $nrOrg);
        $canEdit = $response['dataset'][$hcmServicesRoute]['canEdit'];

        return $canEdit;
    }
}
